package org.ids_mannheim;


import static org.ids_mannheim.TotalNGrams.logger;

public class PaddedSlidingWindowQueue extends SlidingWindowQueue {
    public static final String TEXT_END_SYMBOL = "«END»";
    public static final String TEXT_START_SYMBOL = "«START»";
    public static final String TEXT_STARTEND_POS = "«STARTEND»";
    private static String TEXT_START_COMBO, TEXT_END_COMBO;
    private boolean needsFlush;

    public PaddedSlidingWindowQueue(int size, Increaser flush, boolean with_lemma_and_pos) {
        super(size, flush, with_lemma_and_pos);
        if (with_lemma_and_pos) {
            TEXT_START_COMBO = TEXT_START_SYMBOL + '\t' + TEXT_START_SYMBOL + '\t' + TEXT_STARTEND_POS;
            TEXT_END_COMBO = TEXT_END_SYMBOL + '\t' + TEXT_END_SYMBOL + '\t' + TEXT_STARTEND_POS;
        } else {
            TEXT_START_COMBO = TEXT_START_SYMBOL;
            TEXT_END_COMBO = TEXT_END_SYMBOL;
        }
        logger.info("Using padding.");
        needsFlush = false;
    }

    @Override
    public void reset(int fold) {
        this.clear();
        for (int i = 0; i < maxSize; i++)
            add(TEXT_START_COMBO);
        this.fold = fold;
    }

    @Override
    public void add(String k) {
        super.add(k);
        needsFlush = true;
    }

    @Override
    public void textBreak() {
        if (needsFlush)
            for (int i = 0; i < maxSize; i++)
                add(TEXT_END_COMBO);
    }

}
